;CodeVisionAVR C Compiler V1.24.7e Professional
;(C) Copyright 1998-2005 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega128
;Program type           : Application
;Clock frequency        : 16.000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 1024 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: No
;Enhanced core instructions    : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega128
	#pragma AVRPART MEMORY PROG_FLASH 131072
	#pragma AVRPART MEMORY EEPROM 4096
	#pragma AVRPART MEMORY INT_SRAM SIZE 4096
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x100

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU RAMPZ=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU XMCRA=0x6D
	.EQU XMCRB=0x6C

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_adc_noise_red=0x08
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOV  R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOV  R30,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "main.vec"
	.INCLUDE "main.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30
	STS  XMCRB,R30
	OUT  RAMPZ,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x1000)
	LDI  R25,HIGH(0x1000)
	LDI  R26,LOW(0x100)
	LDI  R27,HIGH(0x100)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x10FF)
	OUT  SPL,R30
	LDI  R30,HIGH(0x10FF)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x500)
	LDI  R29,HIGH(0x500)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x500
;       1 /*****************************************************
;       2 Project : EZ-TFT700T Test Program with ATmega128
;       3 Version : 
;       4 Date    : 2007-  -  
;       5 Comments: 
;       6 Chip type           : ATmega128
;       7 Clock frequency     : 16.000000 MHz
;       8 Memory model        : Small
;       9 External SRAM size  : 0
;      10 Data Stack size     : 1024
;      11 *****************************************************/
;      12 
;      13 #include <mega128.h>   
;      14 #include <delay.h>      
;      15 #include "glib.h"
;      16 #include "UART1.h"
;      17          
;      18 #define SEI()   #asm("sei")     
;      19 #define LCDX    800
;      20 #define LCDY    480
;      21 #define STX     0x02
;      22 #define TSP     0x10
;      23 #define ETX     0x03
;      24 
;      25 #define BLACK         0x00000000
;      26 #define BLUE          0x000000FF
;      27 #define GREEN         0x0000FF00
;      28 #define CYAN          0x0000FFFF
;      29 #define RED           0x00FF0000 
;      30 #define MAGENTA       0x00FF00FF
;      31 #define BROWN         0x00A52A2A
;      32 #define PINK          0x00FFC0CB
;      33 #define SKYBLUE       0x0087CEEB
;      34 #define YELLOW        0x00FFFF00
;      35 #define LIGHTGRAY     0x00D3D3D3
;      36 #define DARKGRAY      0x00A9A9A9
;      37 #define LIGHTBLUE     0x00ADD8E6
;      38 #define LIGHTGREEN    0x0090EE90
;      39 #define LIGHTCYAN     0x00E0FFFF
;      40 #define WHITE         0xFFFFFFFF
;      41 
;      42 interrupt [TIM0_OVF] void timer0_ovf_isr(void);
;      43 void GraphicDemo(void);
;      44 void StringDemo(void);
;      45 void TspDemo(void);
;      46 void InitPort(void);    
;      47 void InitEtc(void);  
;      48 void InitTimer(void);           
;      49 unsigned long GetColor(unsigned char cl);
;      50 
;      51 //----------------------------------------------------------------
;      52 //                    Main Function
;      53 //----------------------------------------------------------------
;      54 void main(void)
;      55 {

	.CSEG
_main:
;      56     InitPort();
	RCALL _InitPort
;      57     InitTimer();        
	RCALL _InitTimer
;      58     InitUart();   
	RCALL _InitUart
;      59     InitEtc();
	RCALL _InitEtc
;      60     
;      61     SEI();
	sei
;      62     delay_ms(1000);               
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;      63     Glib_InitLCD();       
	RCALL _Glib_InitLCD
;      64     GraphicDemo();  
	RCALL _GraphicDemo
;      65     StringDemo();
	RCALL _StringDemo
;      66     TspDemo();
	RCALL _TspDemo
;      67     while (1)
_0x3:
;      68     {
;      69       // 1. Graphic Demo
;      70       // 2. String Demo
;      71       // 3. TSP Demo  -> Open   (ġ ǥ ׷ ǥ)
;      72       //
;      73     };
	RJMP _0x3
;      74 }                     
_0x6:
	RJMP _0x6
;      75 
;      76 void GraphicDemo(void)
;      77 {
_GraphicDemo:
;      78     unsigned long ci; 
;      79     unsigned int x,y,i;
;      80     unsigned char c;
;      81       
;      82     //---------------- Line Demo ----------------
;      83     c = 0;
	SBIW R28,5
	CALL __SAVELOCR6
;	ci -> Y+7
;	x -> R16,R17
;	y -> R18,R19
;	i -> R20,R21
;	c -> Y+6
	LDI  R30,LOW(0)
	STD  Y+6,R30
;      84     for(y=0 ; y<160 ; y++ )               
	__GETWRN 18,19,0
_0x8:
	__CPWRN 18,19,160
	BRSH _0x9
;      85     {           
;      86         ci = c+95;           
	RCALL SUBOPT_0x0
;      87         Glib_SetLineColor(ci<<16);
	__GETD1S 7
	CALL __LSLD16
	RCALL SUBOPT_0x1
;      88         Glib_Line(0,y,799,y);
;      89         c++;
;      90     }     
	__ADDWRN 18,19,1
	RJMP _0x8
_0x9:
;      91     c = 0;    
	LDI  R30,LOW(0)
	STD  Y+6,R30
;      92     for(y=160 ; y<320 ; y++ )               
	__GETWRN 18,19,160
_0xB:
	__CPWRN 18,19,320
	BRSH _0xC
;      93     {           
;      94         ci = c+95;           
	RCALL SUBOPT_0x0
;      95         Glib_SetLineColor(ci<<8);
	__GETD2S 7
	LDI  R30,LOW(8)
	CALL __LSLD12
	RCALL SUBOPT_0x1
;      96         Glib_Line(0,y,799,y);
;      97         c++;
;      98     }     
	__ADDWRN 18,19,1
	RJMP _0xB
_0xC:
;      99     c = 0;    
	LDI  R30,LOW(0)
	STD  Y+6,R30
;     100     for(y=320 ; y<LCDY ; y++ )               
	__GETWRN 18,19,320
_0xE:
	__CPWRN 18,19,480
	BRSH _0xF
;     101     {           
;     102         ci = c+95;           
	RCALL SUBOPT_0x0
;     103         Glib_SetLineColor(ci);
	__GETD1S 7
	RCALL SUBOPT_0x1
;     104         Glib_Line(0,y,799,y);
;     105         c++;
;     106     }    
	__ADDWRN 18,19,1
	RJMP _0xE
_0xF:
;     107     Glib_Beep(200);
	RCALL SUBOPT_0x2
;     108     //---------------- Rectangle Demo ----------------    
;     109     Glib_ClearScreen(WHITE);
;     110 	for(i=0 ; i<200 ; i++ )
	__GETWRN 20,21,0
_0x11:
	__CPWRN 20,21,200
	BRSH _0x12
;     111 	{
;     112 		Glib_SetLineColor(GetColor(i%16));
	RCALL SUBOPT_0x3
;     113 		Glib_Rectangle(400-i, 240-i,  420+i, 250+i);
	SUB  R30,R20
	SBC  R31,R21
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	SUB  R30,R20
	SBC  R31,R21
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R20
	SUBI R30,LOW(-420)
	SBCI R31,HIGH(-420)
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R20
	SUBI R30,LOW(-250)
	SBCI R31,HIGH(-250)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Glib_Rectangle
;     114 	}    
	__ADDWRN 20,21,1
	RJMP _0x11
_0x12:
;     115     Glib_Beep(200);                            
	RCALL SUBOPT_0x2
;     116     //---------------- Circle Demo ----------------    	
;     117     Glib_ClearScreen(WHITE);            
;     118 	for(i=0 ; i<200 ; i++ )
	__GETWRN 20,21,0
_0x14:
	__CPWRN 20,21,200
	BRSH _0x15
;     119 	{
;     120 		Glib_SetLineColor(GetColor(i%16));
	RCALL SUBOPT_0x3
;     121 		Glib_Circle(400, 240, i);
	RCALL SUBOPT_0x4
	ST   -Y,R20
	RCALL _Glib_Circle
;     122 	}
	__ADDWRN 20,21,1
	RJMP _0x14
_0x15:
;     123     Glib_Beep(200);
	RCALL SUBOPT_0x2
;     124     //---------------- Ellipse Demo ----------------    	
;     125     Glib_ClearScreen(WHITE);            
;     126 	for(i=0 ; i<200 ; i++ )
	__GETWRN 20,21,0
_0x17:
	__CPWRN 20,21,200
	BRSH _0x18
;     127 	{
;     128 		Glib_SetLineColor(GetColor(i%16));
	RCALL SUBOPT_0x3
;     129 		Glib_Ellipse(400, 240, i+50, i+10);
	RCALL SUBOPT_0x4
	MOVW R30,R20
	ADIW R30,50
	ST   -Y,R30
	MOVW R30,R20
	ADIW R30,10
	ST   -Y,R30
	RCALL _Glib_Ellipse
;     130 	}
	__ADDWRN 20,21,1
	RJMP _0x17
_0x18:
;     131     Glib_Beep(200);	
	RCALL SUBOPT_0x2
;     132     //---------------- FilledRectangle Demo ----------------    	
;     133     Glib_ClearScreen(WHITE);    
;     134 	for(i=0 ; i<200 ; i+=2 )
	__GETWRN 20,21,0
_0x1A:
	__CPWRN 20,21,200
	BRSH _0x1B
;     135 	{
;     136 		Glib_FilledRectangle(i,i,599+i,i+279,GetColor(i%16));
	ST   -Y,R21
	ST   -Y,R20
	ST   -Y,R21
	ST   -Y,R20
	MOVW R30,R20
	SUBI R30,LOW(-599)
	SBCI R31,HIGH(-599)
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R20
	SUBI R30,LOW(-279)
	SBCI R31,HIGH(-279)
	ST   -Y,R31
	ST   -Y,R30
	RCALL SUBOPT_0x5
	RCALL _Glib_FilledRectangle
;     137 		delay_ms(10);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;     138 	}    
	__ADDWRN 20,21,2
	RJMP _0x1A
_0x1B:
;     139     Glib_Beep(200);	                  
	RCALL SUBOPT_0x2
;     140     //---------------- FilledCircle Demo ----------------    	
;     141     Glib_ClearScreen(WHITE);    
;     142 	for(i=0 ; i<200 ; i+=2 )
	__GETWRN 20,21,0
_0x1D:
	__CPWRN 20,21,200
	BRSH _0x1E
;     143 	{
;     144 		Glib_FilledCircle(400, 240, 200-i,GetColor(i%16));
	LDI  R30,LOW(400)
	LDI  R31,HIGH(400)
	RCALL SUBOPT_0x4
	LDI  R30,LOW(200)
	LDI  R31,HIGH(200)
	SUB  R30,R20
	SBC  R31,R21
	ST   -Y,R30
	RCALL SUBOPT_0x5
	RCALL _Glib_FilledCircle
;     145 		delay_ms(20);		
	RCALL SUBOPT_0x6
;     146 	}    	                           
	__ADDWRN 20,21,2
	RJMP _0x1D
_0x1E:
;     147     Glib_Beep(200);
	RCALL SUBOPT_0x2
;     148     	                  
;     149     //---------------- FilledEllipse Demo ----------------    	
;     150     Glib_ClearScreen(WHITE);            
;     151 	for(i=0 ; i<200 ; i+=2 )
	__GETWRN 20,21,0
_0x20:
	__CPWRN 20,21,200
	BRSH _0x21
;     152 	{
;     153 		Glib_FilledEllipse(400, 240, 200-i+40, 200-i+2, GetColor(i%16));
	LDI  R30,LOW(400)
	LDI  R31,HIGH(400)
	RCALL SUBOPT_0x4
	LDI  R30,LOW(200)
	LDI  R31,HIGH(200)
	SUB  R30,R20
	SBC  R31,R21
	ADIW R30,40
	ST   -Y,R30
	LDI  R30,LOW(200)
	LDI  R31,HIGH(200)
	SUB  R30,R20
	SBC  R31,R21
	ADIW R30,2
	ST   -Y,R30
	RCALL SUBOPT_0x5
	RCALL _Glib_FilledEllipse
;     154 		delay_ms(20);
	RCALL SUBOPT_0x6
;     155 	} 
	__ADDWRN 20,21,2
	RJMP _0x20
_0x21:
;     156     Glib_Beep(200);
	RCALL SUBOPT_0x7
;     157     	
;     158     //---------------- DisplayImage Demo ----------------	
;     159     for(i=10 ; i<20 ; i++ )
	__GETWRN 20,21,10
_0x23:
	__CPWRN 20,21,20
	BRSH _0x24
;     160     {
;     161         Glib_DisplayImage(i, 0, 0);
	ST   -Y,R20
	RCALL SUBOPT_0x8
	RCALL _Glib_DisplayImage
;     162         delay_ms(500);
	RCALL SUBOPT_0x9
;     163     }	
	__ADDWRN 20,21,1
	RJMP _0x23
_0x24:
;     164     delay_ms(1500);      
	LDI  R30,LOW(1500)
	LDI  R31,HIGH(1500)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;     165     Glib_Beep(200);
	RCALL SUBOPT_0x7
;     166         
;     167     //---------------- Screen Push/Pop Demo ----------------	    
;     168     Glib_PushScreen(0,0,400,240);
	RCALL SUBOPT_0x8
	LDI  R30,LOW(400)
	LDI  R31,HIGH(400)
	RCALL SUBOPT_0x4
	RCALL _Glib_PushScreen
;     169     Glib_ClearScreen(WHITE);
	RCALL SUBOPT_0xA
;     170     delay_ms(800);
	RCALL SUBOPT_0xB
;     171     Glib_PopScreen(400,0);
	RCALL SUBOPT_0xC
	RCALL _Glib_PopScreen
;     172     delay_ms(800);
	RCALL SUBOPT_0xB
;     173     Glib_PopScreen(400,240);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0xD
;     174     delay_ms(800);
;     175     Glib_PopScreen(0,240);
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0xD
;     176     delay_ms(800);    
;     177     Glib_PopScreen(0,0);    
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0xD
;     178     delay_ms(800);                                                 
;     179     Glib_Beep(200);
	RCALL SUBOPT_0x2
;     180     
;     181     //---------------- User Char Demo ----------------
;     182     Glib_ClearScreen(WHITE);                
;     183     for(y=0 ; y<30 ; y++ )
	__GETWRN 18,19,0
_0x26:
	__CPWRN 18,19,30
	BRSH _0x27
;     184     {
;     185         Glib_SetLocate(0,y*16);
	RCALL SUBOPT_0xE
	CALL __LSLW4
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Glib_SetLocate
;     186         for(x=0 ; x<50 ; x++)
	__GETWRN 16,17,0
_0x29:
	__CPWRN 16,17,50
	BRSH _0x2A
;     187             Glib_OutUserChar(y%3);
	MOVW R26,R18
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	CALL __MODW21U
	ST   -Y,R30
	RCALL _Glib_OutUserChar
;     188         delay_ms(60); 
	__ADDWRN 16,17,1
	RJMP _0x29
_0x2A:
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;     189     }
	__ADDWRN 18,19,1
	RJMP _0x26
_0x27:
;     190     Glib_Beep(200);
	RCALL SUBOPT_0x7
;     191     Glib_LcdBackLight(0x0A);
	RCALL SUBOPT_0xF
;     192     delay_ms(500);
;     193     Glib_LcdBackLight(0xA0);                            
	RCALL SUBOPT_0x10
;     194     delay_ms(500);    
	RCALL SUBOPT_0x9
;     195     Glib_LcdBackLight(0x0A);
	RCALL SUBOPT_0xF
;     196     delay_ms(500);    
;     197     Glib_LcdBackLight(0xA0);        
	RCALL SUBOPT_0x10
;     198 }
	CALL __LOADLOCR6
	ADIW R28,11
	RET
;     199 
;     200 void StringDemo(void)
;     201 {           
_StringDemo:
;     202     unsigned int i,j,zr;
;     203     
;     204     zr=1;
	CALL __SAVELOCR6
;	i -> R16,R17
;	j -> R18,R19
;	zr -> R20,R21
	__GETWRN 20,21,1
;     205     for(i=0 ; i<10 ; i++)
	__GETWRN 16,17,0
_0x2C:
	__CPWRN 16,17,10
	BRLO PC+3
	JMP _0x2D
;     206     {
;     207         Glib_ClearScreen(WHITE);
	RCALL SUBOPT_0xA
;     208         Glib_SetLocate(0,0);            
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x11
;     209         Glib_SetHangulFont(i%5);
	RCALL _Glib_SetHangulFont
;     210         if(i>4)
	__CPWRN 16,17,5
	BRLO _0x2E
;     211             zr=2;
	__GETWRN 20,21,2
;     212         Glib_SetZoomRate(zr);      
_0x2E:
	RCALL SUBOPT_0x12
;     213         Glib_SetFontColor(GetColor(i),WHITE);
;     214         switch(i)
;     215         {  
;     216             case 0 :
	BREQ _0x33
;     217             case 5 : Glib_OutString("1.ѱ۸1"); 
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BRNE _0x34
_0x33:
	__POINTW1FN _0,0
	RJMP _0x92
;     218                      break;
;     219             case 1 :
_0x34:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BREQ _0x36
;     220             case 6 : Glib_OutString("2.ѱ۸"); 
	CPI  R30,LOW(0x6)
	LDI  R26,HIGH(0x6)
	CPC  R31,R26
	BRNE _0x37
_0x36:
	__POINTW1FN _0,12
	RJMP _0x92
;     221                      break;
;     222             case 2 :
_0x37:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BREQ _0x39
;     223             case 7 : Glib_OutString("3.ѱ۰°"); 
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BRNE _0x3A
_0x39:
	__POINTW1FN _0,23
	RJMP _0x92
;     224                      break;
;     225             case 3 :
_0x3A:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BREQ _0x3C
;     226             case 8 : Glib_OutString("4.ѱ۱"); 
	CPI  R30,LOW(0x8)
	LDI  R26,HIGH(0x8)
	CPC  R31,R26
	BRNE _0x3D
_0x3C:
	__POINTW1FN _0,38
	RJMP _0x92
;     227                      break;
;     228             case 4 :
_0x3D:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BREQ _0x3F
;     229             case 9 : Glib_OutString("5.ѱʱü"); 
	CPI  R30,LOW(0x9)
	LDI  R26,HIGH(0x9)
	CPC  R31,R26
	BRNE _0x31
_0x3F:
	__POINTW1FN _0,53
_0x92:
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Glib_OutString
;     230                      break;                                                               
;     231         }
_0x31:
;     232         for(j=0 ; j<10 ; j++)
	__GETWRN 18,19,0
_0x42:
	__CPWRN 18,19,10
	BRSH _0x43
;     233         {
;     234             Glib_SetLocate(0,16*(j+2)*zr);
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x13
;     235             Glib_OutString("ѱ ׽Ʈ Դϴ.");   
	__POINTW1FN _0,66
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Glib_OutString
;     236         } 
	__ADDWRN 18,19,1
	RJMP _0x42
_0x43:
;     237         delay_ms(500);        
	RCALL SUBOPT_0x9
;     238     }    
	__ADDWRN 16,17,1
	RJMP _0x2C
_0x2D:
;     239      
;     240     zr=1;
	__GETWRN 20,21,1
;     241     for(i=0 ; i<10 ; i++)
	__GETWRN 16,17,0
_0x45:
	__CPWRN 16,17,10
	BRLO PC+3
	JMP _0x46
;     242     {
;     243         Glib_ClearScreen(WHITE);
	RCALL SUBOPT_0xA
;     244         Glib_SetLocate(0,0);            
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x11
;     245         Glib_SetEnglishFont(i%5);
	RCALL _Glib_SetEnglishFont
;     246         if(i>4)
	__CPWRN 16,17,5
	BRLO _0x47
;     247             zr=2;
	__GETWRN 20,21,2
;     248         Glib_SetZoomRate(zr);
_0x47:
	RCALL SUBOPT_0x12
;     249         Glib_SetFontColor(GetColor(i),WHITE);        
;     250         switch(i)
;     251         {  
;     252             case 0 :
	BREQ _0x4C
;     253             case 5 : Glib_OutString("1.1"); 
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BRNE _0x4D
_0x4C:
	__POINTW1FN _0,90
	RJMP _0x93
;     254                      break;
;     255             case 1 :
_0x4D:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BREQ _0x4F
;     256             case 6 : Glib_OutString("2.2"); 
	CPI  R30,LOW(0x6)
	LDI  R26,HIGH(0x6)
	CPC  R31,R26
	BRNE _0x50
_0x4F:
	__POINTW1FN _0,102
	RJMP _0x93
;     257                      break;
;     258             case 2 :
_0x50:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BREQ _0x52
;     259             case 7 : Glib_OutString("3.θ"); 
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BRNE _0x53
_0x52:
	__POINTW1FN _0,114
	RJMP _0x93
;     260                      break;
;     261             case 3 :
_0x53:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BREQ _0x55
;     262             case 8 : Glib_OutString("4."); 
	CPI  R30,LOW(0x8)
	LDI  R26,HIGH(0x8)
	CPC  R31,R26
	BRNE _0x56
_0x55:
	__POINTW1FN _0,129
	RJMP _0x93
;     263                      break;
;     264             case 4 :
_0x56:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BREQ _0x58
;     265             case 9 : Glib_OutString("5.ü"); 
	CPI  R30,LOW(0x9)
	LDI  R26,HIGH(0x9)
	CPC  R31,R26
	BRNE _0x4A
_0x58:
	__POINTW1FN _0,140
_0x93:
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Glib_OutString
;     266                      break;                                                               
;     267         }
_0x4A:
;     268         for(j=0 ; j<10 ; j++)
	__GETWRN 18,19,0
_0x5B:
	__CPWRN 18,19,10
	BRSH _0x5C
;     269         {
;     270             Glib_SetLocate(0,16*(j+2)*zr);
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x13
;     271             Glib_OutString("This is English font demonstration.");
	__POINTW1FN _0,153
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Glib_OutString
;     272         }       
	__ADDWRN 18,19,1
	RJMP _0x5B
_0x5C:
;     273         delay_ms(500);             
	RCALL SUBOPT_0x9
;     274     }    
	__ADDWRN 16,17,1
	RJMP _0x45
_0x46:
;     275 }                                                              
	CALL __LOADLOCR6
	ADIW R28,6
	RET
;     276 
;     277 //-------------------- TspDemo Function ---------------------        
;     278 void TspDemo(void)
;     279 {
_TspDemo:
;     280     unsigned char rxcnt, b, sflow, rxBuf[5];            
;     281     unsigned int x, y;
;     282             
;     283     Glib_TspOnOff(0xA0);     // TSP On       
	SBIW R28,7
	CALL __SAVELOCR5
;	rxcnt -> R16
;	b -> R17
;	sflow -> R18
;	rxBuf -> Y+7
;	x -> R19,R20
;	y -> Y+5
	LDI  R30,LOW(160)
	ST   -Y,R30
	RCALL _Glib_TspOnOff
;     284     Glib_SetTspMode(0x0A);   // Down only
	LDI  R30,LOW(10)
	ST   -Y,R30
	RCALL _Glib_SetTspMode
;     285     Glib_TspBeepOnOff(0xA0); // Beep On
	LDI  R30,LOW(160)
	ST   -Y,R30
	RCALL _Glib_TspBeepOnOff
;     286     
;     287     Glib_ClearScreen(WHITE);                                           
	RCALL SUBOPT_0xA
;     288     Glib_SetLineColor(BLACK);
	__GETD1N 0x0
	CALL __PUTPARD1
	RCALL _Glib_SetLineColor
;     289     Glib_SetLineWidth(2);           
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _Glib_SetLineWidth
;     290     Glib_SetFontColor(BLACK, WHITE);
	__GETD1N 0x0
	CALL __PUTPARD1
	__GETD1N 0xFFFFFFFF
	CALL __PUTPARD1
	RCALL _Glib_SetFontColor
;     291     Glib_SetLocate(10,0);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL SUBOPT_0xC
	RCALL _Glib_SetLocate
;     292     Glib_OutString("<TSP TEST>");
	__POINTW1FN _0,189
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Glib_OutString
;     293     sflow = 100;
	LDI  R18,LOW(100)
;     294     while(1)
_0x5D:
;     295     {
;     296         if(RsReady1())
	RCALL _RsReady1
	CPI  R30,0
	BRNE PC+3
	JMP _0x60
;     297         {                    
;     298             b = RsIn1();       
	RCALL _RsIn1
	MOV  R17,R30
;     299             switch(sflow)
	MOV  R30,R18
;     300             {
;     301                 case 100 : if(b==STX)
	CPI  R30,LOW(0x64)
	BRNE _0x64
	CPI  R17,2
	BRNE _0x65
;     302                                sflow = 200;
	LDI  R18,LOW(200)
;     303                            break;
_0x65:
	RJMP _0x63
;     304                 case 200 : if(b==TSP)      
_0x64:
	CPI  R30,LOW(0xC8)
	BRNE _0x66
	CPI  R17,16
	BRNE _0x67
;     305                            {
;     306                                sflow = 300;
	LDI  R18,LOW(300)
;     307                                rxcnt = 0;
	LDI  R16,LOW(0)
;     308                            }
;     309                            else
	RJMP _0x68
_0x67:
;     310                                sflow = 100;
	LDI  R18,LOW(100)
;     311                            break;          
_0x68:
	RJMP _0x63
;     312                 case 300 : rxBuf[rxcnt++] = b;
_0x66:
	CPI  R30,LOW(0x12C)
	BRNE _0x69
	MOV  R30,R16
	SUBI R16,-1
	LDI  R31,0
	MOVW R26,R28
	ADIW R26,7
	ADD  R26,R30
	ADC  R27,R31
	ST   X,R17
;     313                            if(rxcnt>=5)
	CPI  R16,5
	BRLO _0x6A
;     314                                sflow = 400;
	LDI  R18,LOW(400)
;     315                            break;
_0x6A:
	RJMP _0x63
;     316                 case 400 : if(b==ETX)
_0x69:
	CPI  R30,LOW(0x190)
	BREQ PC+3
	JMP _0x63
	CPI  R17,3
	BREQ PC+3
	JMP _0x6C
;     317                            {     
;     318                                x = (unsigned int)rxBuf[0]*256+rxBuf[1];
	LDD  R31,Y+7
	LDI  R30,LOW(0)
	MOVW R26,R30
	LDD  R30,Y+8
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	__PUTW1R 19,20
;     319                                y = (unsigned int)rxBuf[2]*256+rxBuf[3];
	LDD  R31,Y+9
	LDI  R30,LOW(0)
	MOVW R26,R30
	LDD  R30,Y+10
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	STD  Y+5,R30
	STD  Y+5+1,R31
;     320                                if((x<LCDX) && (y<LCDY))
	__CPWRN 19,20,800
	BRSH _0x6E
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	CPI  R26,LOW(0x1E0)
	LDI  R30,HIGH(0x1E0)
	CPC  R27,R30
	BRLO _0x6F
_0x6E:
	RJMP _0x6D
_0x6F:
;     321                                {
;     322                                    Glib_Line(x-10,y,x+10,y);
	__GETW1R 19,20
	SBIW R30,10
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	ST   -Y,R31
	ST   -Y,R30
	__GETW1R 19,20
	ADIW R30,10
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+11
	LDD  R31,Y+11+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Glib_Line
;     323                                    Glib_Line(x,y-10,x,y+10); 
	ST   -Y,R20
	ST   -Y,R19
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	SBIW R30,10
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R20
	ST   -Y,R19
	LDD  R30,Y+11
	LDD  R31,Y+11+1
	ADIW R30,10
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Glib_Line
;     324                                }
;     325                            }
_0x6D:
;     326                            sflow = 100;
_0x6C:
	LDI  R18,LOW(100)
;     327                            break;
;     328             }
_0x63:
;     329         }             
;     330     }
_0x60:
	RJMP _0x5D
;     331 }
;     332 
;     333 //--------------------------------------------------------------
;     334 //             Timer0 Interrupt Service Routine
;     335 //--------------------------------------------------------------
;     336 interrupt [TIM0_OVF] void timer0_ovf_isr(void)
;     337 {
_timer0_ovf_isr:
;     338 // Place your code here
;     339 }
	RETI
;     340 
;     341 //-------------------- InitTimer Function ---------------------
;     342 void InitTimer(void)
;     343 {
_InitTimer:
;     344     // Timer/Counter 0 initialization
;     345     // Clock value: 125.000 kHz
;     346     ASSR=0x00; TCCR0=0x05; TCNT0=0x00; OCR0=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
	LDI  R30,LOW(5)
	OUT  0x33,R30
	LDI  R30,LOW(0)
	OUT  0x32,R30
	OUT  0x31,R30
;     347 
;     348     // Timer/Counter 1 initialization
;     349     TCCR1A=0x00; TCCR1B=0x00; TCNT1H=0x00; TCNT1L=0x00;
	OUT  0x2F,R30
	OUT  0x2E,R30
	OUT  0x2D,R30
	OUT  0x2C,R30
;     350     ICR1H=0x00; ICR1L=0x00;
	OUT  0x27,R30
	OUT  0x26,R30
;     351     OCR1AH=0x00; OCR1AL=0x00; OCR1BH=0x00; OCR1BL=0x00; OCR1CH=0x00; OCR1CL=0x00;
	OUT  0x2B,R30
	OUT  0x2A,R30
	OUT  0x29,R30
	OUT  0x28,R30
	STS  121,R30
	STS  120,R30
;     352 
;     353     // Timer/Counter 2 initialization
;     354     TCCR2=0x00; TCNT2=0x00; OCR2=0x00;
	OUT  0x25,R30
	OUT  0x24,R30
	OUT  0x23,R30
;     355 
;     356     // Timer/Counter 3 initialization
;     357     TCCR3A=0x00; TCCR3B=0x00; TCNT3H=0x00; TCNT3L=0x00;
	STS  139,R30
	STS  138,R30
	STS  137,R30
	STS  136,R30
;     358     ICR3H=0x00; ICR3L=0x00;
	STS  129,R30
	STS  128,R30
;     359     OCR3AH=0x00; OCR3AL=0x00; OCR3BH=0x00; OCR3BL=0x00; OCR3CH=0x00; OCR3CL=0x00;
	STS  135,R30
	STS  134,R30
	STS  133,R30
	STS  132,R30
	STS  131,R30
	STS  130,R30
;     360 
;     361     // Timer(s)/Counter(s) Interrupt(s) initialization
;     362     TIMSK=0x01;  ETIMSK=0x00;    
	LDI  R30,LOW(1)
	OUT  0x37,R30
	LDI  R30,LOW(0)
	STS  125,R30
;     363 }
	RET
;     364                                                
;     365 //-------------------- InitPort Function ----------------------
;     366 void InitPort(void)
;     367 {
_InitPort:
;     368     PORTA=0x00; DDRA=0x00;
	LDI  R30,LOW(0)
	OUT  0x1B,R30
	OUT  0x1A,R30
;     369     PORTB=0x00; DDRB=0x00;
	OUT  0x18,R30
	OUT  0x17,R30
;     370     PORTC=0x00; DDRC=0x00;
	OUT  0x15,R30
	OUT  0x14,R30
;     371     PORTD=0x08; DDRD=0x08;
	LDI  R30,LOW(8)
	OUT  0x12,R30
	OUT  0x11,R30
;     372     PORTE=0x00; DDRE=0x00;
	LDI  R30,LOW(0)
	OUT  0x3,R30
	OUT  0x2,R30
;     373     PORTF=0x00; DDRF=0x00;
	STS  98,R30
	STS  97,R30
;     374     PORTG=0x00; DDRG=0x00;
	STS  101,R30
	STS  100,R30
;     375 }       
	RET
;     376 
;     377 //-------------------- InitEtc Function ----------------------
;     378 void InitEtc(void)
;     379 {
_InitEtc:
;     380     // External Interrupt(s) initialization
;     381     EICRA=0x00; EICRB=0x00; EIMSK=0x00;
	LDI  R30,LOW(0)
	STS  106,R30
	OUT  0x3A,R30
	OUT  0x39,R30
;     382     // Analog Comparator initialization
;     383     ACSR=0x80; SFIOR=0x00;
	LDI  R30,LOW(128)
	OUT  0x8,R30
	LDI  R30,LOW(0)
	OUT  0x20,R30
;     384 }       
	RET
;     385 
;     386 //-------------------- GetColor Function ----------------------                                                             
;     387 unsigned long GetColor(unsigned char cl)
;     388 {
_GetColor:
;     389 	unsigned long clcl;
;     390 	
;     391 	switch(cl)
	SBIW R28,4
;	cl -> Y+4
;	clcl -> Y+0
	LDD  R30,Y+4
;     392 	{
;     393 		case 0 : clcl = BLACK; break;
	CPI  R30,0
	BRNE _0x73
	__CLRD1S 0
	RJMP _0x72
;     394 		case 1 : clcl = BLUE; break;
_0x73:
	CPI  R30,LOW(0x1)
	BRNE _0x74
	__GETD1N 0xFF
	RJMP _0x94
;     395 		case 2 : clcl = GREEN; break;
_0x74:
	CPI  R30,LOW(0x2)
	BRNE _0x75
	__GETD1N 0xFF00
	RJMP _0x94
;     396 		case 3 : clcl = CYAN; break;
_0x75:
	CPI  R30,LOW(0x3)
	BRNE _0x76
	__GETD1N 0xFFFF
	RJMP _0x94
;     397 		case 4 : clcl = RED; break;
_0x76:
	CPI  R30,LOW(0x4)
	BRNE _0x77
	__GETD1N 0xFF0000
	RJMP _0x94
;     398 		case 5 : clcl = MAGENTA; break;
_0x77:
	CPI  R30,LOW(0x5)
	BRNE _0x78
	__GETD1N 0xFF00FF
	RJMP _0x94
;     399 		case 6 : clcl = BROWN; break;
_0x78:
	CPI  R30,LOW(0x6)
	BRNE _0x79
	__GETD1N 0xA52A2A
	RJMP _0x94
;     400 		case 7 : clcl = PINK; break;		
_0x79:
	CPI  R30,LOW(0x7)
	BRNE _0x7A
	__GETD1N 0xFFC0CB
	RJMP _0x94
;     401 		case 8 : clcl = SKYBLUE; break;												
_0x7A:
	CPI  R30,LOW(0x8)
	BRNE _0x7B
	__GETD1N 0x87CEEB
	RJMP _0x94
;     402 		case 9 : clcl = YELLOW; break;		
_0x7B:
	CPI  R30,LOW(0x9)
	BRNE _0x7C
	__GETD1N 0xFFFF00
	RJMP _0x94
;     403 		case 10: clcl = LIGHTGRAY; break;		
_0x7C:
	CPI  R30,LOW(0xA)
	BRNE _0x7D
	__GETD1N 0xD3D3D3
	RJMP _0x94
;     404 		case 11: clcl = DARKGRAY; break;		
_0x7D:
	CPI  R30,LOW(0xB)
	BRNE _0x7E
	__GETD1N 0xA9A9A9
	RJMP _0x94
;     405 		case 12: clcl = LIGHTBLUE; break;		
_0x7E:
	CPI  R30,LOW(0xC)
	BRNE _0x7F
	__GETD1N 0xADD8E6
	RJMP _0x94
;     406 		case 13: clcl = LIGHTGREEN; break;		
_0x7F:
	CPI  R30,LOW(0xD)
	BRNE _0x80
	__GETD1N 0x90EE90
	RJMP _0x94
;     407 		case 14: clcl = LIGHTCYAN; break;		
_0x80:
	CPI  R30,LOW(0xE)
	BRNE _0x81
	__GETD1N 0xE0FFFF
	RJMP _0x94
;     408 		case 15: clcl = WHITE; break;		
_0x81:
	CPI  R30,LOW(0xF)
	BRNE _0x72
	__GETD1N 0xFFFFFFFF
_0x94:
	__PUTD1S 0
;     409 	}		    
_0x72:
;     410 	return(clcl);
	__GETD1S 0
	ADIW R28,5
	RET
;     411 }
;     412 
;     413 
;     414             
;     415 
;     416 #include "UART1.h"
;     417                    
;     418 #define SEI()   #asm("sei")
;     419 
;     420 #define RXB8 1
;     421 #define TXB8 0
;     422 #define UPE  2
;     423 #define OVR  3
;     424 #define FE   4
;     425 #define UDRE 5
;     426 #define RXC  7
;     427 
;     428 #define FRAMING_ERROR (1<<FE)
;     429 #define PARITY_ERROR (1<<UPE)
;     430 #define DATA_OVERRUN (1<<OVR)
;     431 #define DATA_REGISTER_EMPTY (1<<UDRE)
;     432 #define RX_COMPLETE (1<<RXC)
;     433 #define RX_BUFFER_SIZE1 128
;     434 
;     435 // USART1 Receiver buffer & Variables
;     436 unsigned char rx_buffer1[RX_BUFFER_SIZE1];

	.DSEG
_rx_buffer1:
	.BYTE 0x80
;     437 unsigned char rx_wr_index1,rx_rd_index1,rx_counter1;
;     438 bit rx_buffer_overflow1;
;     439 
;     440 //----------------- UART1 Receive ISR ----------------------------
;     441 interrupt [USART1_RXC] void usart1_rx_isr(void)
;     442 {

	.CSEG
_usart1_rx_isr:
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
;     443     unsigned char status,data;
;     444     status=UCSR1A;
	ST   -Y,R17
	ST   -Y,R16
;	status -> R16
;	data -> R17
	LDS  R16,155
;     445     data = UDR1;
	LDS  R17,156
;     446     
;     447 //    if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0)
;     448 //   {
;     449        rx_buffer1[rx_wr_index1]=data;
	MOV  R26,R4
	LDI  R27,0
	SUBI R26,LOW(-_rx_buffer1)
	SBCI R27,HIGH(-_rx_buffer1)
	ST   X,R17
;     450        if (++rx_wr_index1 == RX_BUFFER_SIZE1) 
	INC  R4
	LDI  R30,LOW(128)
	CP   R30,R4
	BRNE _0x83
;     451            rx_wr_index1=0;
	CLR  R4
;     452        if (++rx_counter1 == RX_BUFFER_SIZE1)
_0x83:
	INC  R6
	LDI  R30,LOW(128)
	CP   R30,R6
	BRNE _0x84
;     453       {
;     454           rx_counter1=0;
	CLR  R6
;     455           rx_buffer_overflow1=1;
	SET
	BLD  R2,0
;     456       }
;     457 //   }    
;     458 }                                     
_0x84:
	LD   R16,Y+
	LD   R17,Y+
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	RETI
;     459 
;     460 //----------------- UART1 RsIn1 Function ------------------------
;     461 unsigned char RsIn1(void)
;     462 {
_RsIn1:
;     463     char data;
;     464     data=rx_buffer1[rx_rd_index1];
	ST   -Y,R16
;	data -> R16
	MOV  R30,R5
	LDI  R31,0
	SUBI R30,LOW(-_rx_buffer1)
	SBCI R31,HIGH(-_rx_buffer1)
	LD   R16,Z
;     465     if (++rx_rd_index1 == RX_BUFFER_SIZE1) 
	INC  R5
	LDI  R30,LOW(128)
	CP   R30,R5
	BRNE _0x85
;     466         rx_rd_index1=0;
	CLR  R5
;     467     #asm("cli")
_0x85:
	cli
;     468     --rx_counter1;
	DEC  R6
;     469     #asm("sei")
	sei
;     470     return data;
	MOV  R30,R16
	LD   R16,Y+
	RET
;     471 }                          
;     472 
;     473 //----------------- UART1 RsReady1 Function ---------------------
;     474 unsigned char RsReady1(void)
;     475 {
_RsReady1:
;     476     if(rx_counter1>0)
	LDI  R30,LOW(0)
	CP   R30,R6
	BRSH _0x86
;     477         return(1);
	LDI  R30,LOW(1)
	RET
;     478     else
_0x86:
;     479         return(0);        
	LDI  R30,LOW(0)
	RET
;     480 }                 
	RET
;     481                                               
;     482 //----------------- UART1 RsOut1 Function ----------------------
;     483 void RsOut1(char c)
;     484 {
_RsOut1:
;     485     while ((UCSR1A & DATA_REGISTER_EMPTY)==0);
_0x88:
	LDS  R30,155
	ANDI R30,LOW(0x20)
	BREQ _0x88
;     486     UDR1=c;
	LD   R30,Y
	STS  156,R30
;     487 }
	RJMP _0x8E
;     488 
;     489 //----------------- UART1 InitUart Function ----------------------
;     490 void InitUart(void)
;     491 {
_InitUart:
;     492     // USART1 initialization, 19200bps 8N1
;     493     UCSR1A=0x00; UCSR1B=0x98; UCSR1C=0x06; UBRR1H=0x00; UBRR1L=0x33;
	LDI  R30,LOW(0)
	STS  155,R30
	LDI  R30,LOW(152)
	STS  154,R30
	LDI  R30,LOW(6)
	STS  157,R30
	RCALL SUBOPT_0x14
	STS  153,R30
;     494     UCSR0A=0x00; UCSR0B=0x98; UCSR0C=0x06; UBRR1H=0x00; UBRR0L=0x33;    
	LDI  R30,LOW(0)
	OUT  0xB,R30
	LDI  R30,LOW(152)
	OUT  0xA,R30
	LDI  R30,LOW(6)
	STS  149,R30
	RCALL SUBOPT_0x14
	OUT  0x9,R30
;     495 }
	RET
;     496 #include <string.h>
;     497 #include "UART1.h"
;     498 #include "GLIB.h"                            
;     499 
;     500              
;     501 #define STX 0x02
;     502 #define ETX 0x03       
;     503 
;     504 //==================================================================
;     505 //                     LCD  ɱ
;     506 //==================================================================
;     507 
;     508 //--------------------- Glib_InitLCD Function ----------------------
;     509 //  : 0x02 0x1A 0x10 0x03
;     510 void Glib_InitLCD(void)
;     511 {
_Glib_InitLCD:
;     512     RsOut1(STX);
	RCALL SUBOPT_0x15
;     513     RsOut1(0x1A);
;     514     RsOut1(0x10);
	RCALL SUBOPT_0x16
;     515     RsOut1(ETX);
	RCALL SUBOPT_0x17
;     516 }
	RET
;     517 
;     518 //-------------------- Glib_SetBaudRate Function --------------------
;     519 //  : 0x02 0x1A 0x11 br 0x03
;     520 // 1200bps -> 0,  2400bps -> 1,  4800bps -> 2, 9600bps ->3
;     521 // 19200bps -> 4(Default), 38400bps -> 5, 57600bps -> 6, 115200bps -> 7
;     522 void Glib_SetBaudRate(unsigned char br)
;     523 {
;     524     RsOut1(STX);
;     525     RsOut1(0x1A);
;     526     RsOut1(0x11);
;     527     RsOut1(br);    
;     528     RsOut1(ETX);    
;     529 }                                         
;     530 
;     531 //--------------------- Glib_TspOnOff Function ----------------------
;     532 //  : 0x02 0x1A 0x12 flag 0x03
;     533 // flag: 0xA0->ON,  0x0A->OFF(Default)
;     534 void Glib_TspOnOff(unsigned char flag)
;     535 {
_Glib_TspOnOff:
;     536     RsOut1(STX);
	RCALL SUBOPT_0x15
;     537     RsOut1(0x1A);
;     538     RsOut1(0x12);
	RCALL SUBOPT_0x18
;     539     RsOut1(flag);    
	RCALL SUBOPT_0x19
;     540     RsOut1(ETX);   
;     541 }
	RJMP _0x8E
;     542  
;     543 //-------------------- Glib_SetTspMode Function ---------------------
;     544 //  : 0x02 0x1A 0x13 flag 0x03
;     545 // flag: 0xA0->Up/Down Event(Default),  0x0A->Down Event only
;     546 void Glib_SetTspMode(unsigned char flag)
;     547 {
_Glib_SetTspMode:
;     548     RsOut1(STX);
	RCALL SUBOPT_0x15
;     549     RsOut1(0x1A);
;     550     RsOut1(0x13);
	RCALL SUBOPT_0x1A
;     551     RsOut1(flag);    
	RCALL SUBOPT_0x19
;     552     RsOut1(ETX);   
;     553 }
	RJMP _0x8E
;     554 
;     555 //------------------- Glib_LcdBackLight Function --------------------
;     556 //  : 0x02 0x1A 0x14 flag 0x03
;     557 // flag: 0xA0->On,  0x0A->Off(default)
;     558 void Glib_LcdBackLight(unsigned char flag)
;     559 {
_Glib_LcdBackLight:
;     560     RsOut1(STX);
	RCALL SUBOPT_0x15
;     561     RsOut1(0x1A);
;     562     RsOut1(0x14);
	RCALL SUBOPT_0x1B
;     563     RsOut1(flag);    
;     564     RsOut1(ETX);   
;     565 }
	RJMP _0x8E
;     566 
;     567 //---------------- Glib_SetFullDisplayMode Function -----------------
;     568 //  : 0x02 0x1A 0x15 flag 0x03
;     569 // flag: 0xA0->use PCI function(default),  0x0A->don't use PCI function
;     570 void Glib_SetFullDisplayMode(unsigned char flag)
;     571 {
;     572     RsOut1(STX);
;     573     RsOut1(0x15);
;     574     RsOut1(0x14);
;     575     RsOut1(flag);    
;     576     RsOut1(ETX);   
;     577 }
;     578 
;     579          
;     580 //==================================================================
;     581 //                      ׷  ɱ
;     582 //==================================================================                                                                     
;     583 
;     584 //------------------ Glib_SetHangulFont Function -------------------
;     585 //  : 0x02 0x1B 0x10 hIndex 0x03
;     586 // hIndex: ѱ۸1->0(default), ѱ۸2->1, ѱ۰°->2
;     587 //         ѱ۱->3, ѱʱü->4          
;     588 void Glib_SetHangulFont(unsigned char hIndex)
;     589 {
_Glib_SetHangulFont:
;     590     RsOut1(STX);
	RCALL SUBOPT_0x1C
;     591     RsOut1(0x1B);
;     592     RsOut1(0x10);
	RCALL SUBOPT_0x16
;     593     RsOut1(hIndex);    
	RCALL SUBOPT_0x19
;     594     RsOut1(ETX);   
;     595 }
	RJMP _0x8E
;     596  
;     597 //------------------ Glib_SetEnglishFont Function -------------------
;     598 //  : 0x02 0x1B 0x11 eIndex 0x03
;     599 // hIndex: 1->0(default), 2->1, θ->2
;     600 //         ->3, ü->4          
;     601 void Glib_SetEnglishFont(unsigned char eIndex)
;     602 {
_Glib_SetEnglishFont:
;     603     RsOut1(STX);
	RCALL SUBOPT_0x1C
;     604     RsOut1(0x1B);
;     605     RsOut1(0x11);
	RCALL SUBOPT_0x1D
;     606     RsOut1(eIndex);    
;     607     RsOut1(ETX);   
;     608 }
	RJMP _0x8E
;     609 
;     610  
;     611 //------------------ Glib_SetFontColor Function -------------------
;     612 //  : 0x02 0x1B 0x12 ForeColor BackColor 0x03
;     613 // ForeColor, Backcolor -> R G B   1Ʈ  3Ʈ 
;     614 // Default -> ForeColor:Black, BackColor=White
;     615 void Glib_SetFontColor(unsigned long fColor, unsigned long bColor)
;     616 {
_Glib_SetFontColor:
;     617     RsOut1(STX);
	RCALL SUBOPT_0x1C
;     618     RsOut1(0x1B);
;     619     RsOut1(0x12);
	RCALL SUBOPT_0x18
;     620     RsOut1((unsigned char)((fColor>>16)&0xFF));
	__GETD1S 4
	RCALL SUBOPT_0x1E
;     621     RsOut1((unsigned char)((fColor>>8)&0xFF));
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	RCALL SUBOPT_0x1F
;     622     RsOut1((unsigned char)(fColor&0xFF)); 
	__GETD1S 4
	RCALL SUBOPT_0x20
;     623     RsOut1((unsigned char)((bColor>>16)&0xFF));
	__GETD1S 0
	RCALL SUBOPT_0x1E
;     624     RsOut1((unsigned char)((bColor>>8)&0xFF));
	LD   R30,Y
	LDD  R31,Y+1
	RCALL SUBOPT_0x1F
;     625     RsOut1((unsigned char)(bColor&0xFF)); 
	__GETD1S 0
	RCALL SUBOPT_0x20
;     626     RsOut1(ETX);   
	RCALL SUBOPT_0x17
;     627 }
	RJMP _0x90
;     628 
;     629 //------------------ Glib_SetLineColor Function -------------------
;     630 //  : 0x02 0x1B 0x13 LineColor 0x03
;     631 // LineColor -> R G B   1Ʈ  3Ʈ      
;     632 // Default -> Black
;     633 void Glib_SetLineColor(unsigned long lineColor)
;     634 {
_Glib_SetLineColor:
;     635     RsOut1(STX);
	RCALL SUBOPT_0x1C
;     636     RsOut1(0x1B);
;     637     RsOut1(0x13);
	RCALL SUBOPT_0x1A
;     638     RsOut1((unsigned char)((lineColor>>16)&0xFF));
	__GETD1S 0
	RCALL SUBOPT_0x1E
;     639     RsOut1((unsigned char)((lineColor>>8)&0xFF));
	LD   R30,Y
	LDD  R31,Y+1
	RCALL SUBOPT_0x1F
;     640     RsOut1((unsigned char)(lineColor&0xFF)); 
	__GETD1S 0
	RCALL SUBOPT_0x20
;     641     RsOut1(ETX);   
	RCALL SUBOPT_0x17
;     642 } 
	RJMP _0x8F
;     643 
;     644 //------------------ Glib_SetLineWidth Function -------------------
;     645 //  : 0x02 0x1B 0x14 LineWidth 0x03
;     646 // LineWidth -> 1~7 (default=1)
;     647 void Glib_SetLineWidth(unsigned char lineWidth)
;     648 {
_Glib_SetLineWidth:
;     649     RsOut1(STX);
	RCALL SUBOPT_0x1C
;     650     RsOut1(0x1B);
;     651     RsOut1(0x14);
	RCALL SUBOPT_0x1B
;     652     RsOut1(lineWidth); 
;     653     RsOut1(ETX);   
;     654 }   
	RJMP _0x8E
;     655 
;     656 
;     657 //==================================================================
;     658 //                      Ʈ ɱ
;     659 //==================================================================                                                                     
;     660 
;     661 //-------------------- Glib_SetLocate Function ---------------------
;     662 //  : 0x02 0x1C 0x10 Xposition Yposition 0x03 
;     663 // Xposition, Yposition -> X, Y ǥ Ʈ    
;     664 // Default -> (0, 0)
;     665 void Glib_SetLocate(unsigned int xx, unsigned int yy)
;     666 {
_Glib_SetLocate:
;     667     RsOut1(STX);
	RCALL SUBOPT_0x21
;     668     RsOut1(0x1C);
;     669     RsOut1(0x10);
	RCALL SUBOPT_0x16
;     670     RsOut1((unsigned char)((xx>>8)&0xFF));
	RCALL SUBOPT_0x22
;     671     RsOut1((unsigned char)(xx&0xFF)); 
;     672     RsOut1((unsigned char)((yy>>8)&0xFF));
;     673     RsOut1((unsigned char)(yy&0xFF));     
;     674     RsOut1(ETX);
;     675 }               
	RJMP _0x8F
;     676 
;     677 //-------------------- Glib_SetZoomRate Function ---------------------
;     678 //  : 0x02 0x1C 0x11 ZoomRate 0x03 
;     679 // ZoomRate -> 1(default) or 2;     680 void Glib_SetZoomRate(unsigned char zoomRate)
;     681 {
_Glib_SetZoomRate:
;     682     RsOut1(STX);
	RCALL SUBOPT_0x21
;     683     RsOut1(0x1C);
;     684     RsOut1(0x11);
	RCALL SUBOPT_0x1D
;     685     RsOut1(zoomRate);     
;     686     RsOut1(ETX);
;     687 }                  
	RJMP _0x8E
;     688 
;     689 //-------------------- Glib_FontBackMode Function ---------------------
;     690 //  : 0x02 0x1C 0x12 flag 0x03 
;     691 // flag -> 0xA0(use background font color, default), 0x0A(don't use)
;     692 void Glib_FontBackMode(unsigned char flag)
;     693 {
;     694     RsOut1(STX);
;     695     RsOut1(0x1C);
;     696     RsOut1(0x12);
;     697     RsOut1(flag);     
;     698     RsOut1(ETX);
;     699 }                  
;     700  
;     701 //-------------------- Glib_CursorOnOff Function ---------------------
;     702 //  : 0x02 0x1C 0x13 flag 0x03 
;     703 // flag -> 0xA0(cursor on), 0x0A(cursor off, default)
;     704 void Glib_CursorOnOff(unsigned char flag)
;     705 {
;     706     RsOut1(STX);
;     707     RsOut1(0x1C);
;     708     RsOut1(0x13);
;     709     RsOut1(flag);     
;     710     RsOut1(ETX);
;     711 }
;     712                
;     713 //-------------------- Glib_SetHanCodeType Function ---------------------
;     714 //  : 0x02 0x1C 0x14 code 0x03 
;     715 // code -> 0(ϼ, default), 1()
;     716 void Glib_SetHanCodeType(unsigned char code)
;     717 {
;     718     RsOut1(STX);
;     719     RsOut1(0x1C);
;     720     RsOut1(0x14);
;     721     RsOut1(code);     
;     722     RsOut1(ETX);
;     723 } 
;     724                
;     725 //-------------------- Glib_OutString Function ---------------------
;     726 //  : 0x02 0x1C 0x15 StrLen String 0x03 
;     727 // StrLen -> String Length(1~100), String -> String constant                 
;     728 void Glib_OutString(flash unsigned char *str)
;     729 {              
_Glib_OutString:
;     730     unsigned char i, cnt;
;     731     
;     732     cnt = strlenf(str);   //codevision ڿ  Ҷ
	ST   -Y,R17
	ST   -Y,R16
;	*str -> Y+2
;	i -> R16
;	cnt -> R17
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _strlenf
	MOV  R17,R30
;     733     RsOut1(STX);
	RCALL SUBOPT_0x21
;     734     RsOut1(0x1C);
;     735     RsOut1(0x15);    
	RCALL SUBOPT_0x23
;     736     RsOut1(cnt);
	ST   -Y,R17
	RCALL _RsOut1
;     737     for(i=0 ; i<cnt ; i++)
	LDI  R16,LOW(0)
_0x8C:
	CP   R16,R17
	BRSH _0x8D
;     738         RsOut1(str[i]);
	MOV  R30,R16
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	LPM  R30,Z
	ST   -Y,R30
	RCALL _RsOut1
;     739     RsOut1(ETX);
	SUBI R16,-1
	RJMP _0x8C
_0x8D:
	RCALL SUBOPT_0x17
;     740 }                                                            
	LDD  R17,Y+1
	LDD  R16,Y+0
	RJMP _0x8F
;     741 
;     742 
;     743 //==================================================================
;     744 //                      ׷ Լ ɱ
;     745 //==================================================================                                                                     
;     746 
;     747 //-------------------- Glib_PutPixel Function ---------------------
;     748 //  : 0x02 0x1D 0x10 X Y 0x03 
;     749 // X, Y -> X, Y ǥ Ʈ    
;     750 void Glib_PutPixel(unsigned int xx, unsigned int yy)               
;     751 {
;     752     RsOut1(STX);
;     753     RsOut1(0x1D);
;     754     RsOut1(0x10);    
;     755     RsOut1((unsigned char)((xx>>8)&0xFF));
;     756     RsOut1((unsigned char)(xx&0xFF)); 
;     757     RsOut1((unsigned char)((yy>>8)&0xFF));
;     758     RsOut1((unsigned char)(yy&0xFF));     
;     759     RsOut1(ETX);                   
;     760 }
;     761 
;     762 //-------------------- Glib_Line Function ---------------------
;     763 //  : 0x02 0x1D 0x11 X1 Y1 X2 Y2 0x03 
;     764 // (X1, Y1)~(X2, Y2) -> X, Y ǥ Ʈ    
;     765 void Glib_Line(unsigned int x1, unsigned int y1, unsigned int x2, unsigned int y2)               
;     766 {
_Glib_Line:
;     767     RsOut1(STX);
	RCALL SUBOPT_0x24
;     768     RsOut1(0x1D);
;     769     RsOut1(0x11);    
	LDI  R30,LOW(17)
	RCALL SUBOPT_0x25
;     770     RsOut1((unsigned char)((x1>>8)&0xFF));
;     771     RsOut1((unsigned char)(x1&0xFF)); 
;     772     RsOut1((unsigned char)((y1>>8)&0xFF));
;     773     RsOut1((unsigned char)(y1&0xFF));
;     774     RsOut1((unsigned char)((x2>>8)&0xFF));
	RCALL SUBOPT_0x22
;     775     RsOut1((unsigned char)(x2&0xFF)); 
;     776     RsOut1((unsigned char)((y2>>8)&0xFF));
;     777     RsOut1((unsigned char)(y2&0xFF));              
;     778     RsOut1(ETX);                   
;     779 }
	RJMP _0x90
;     780 
;     781 //-------------------- Glib_Rectangle Function ---------------------
;     782 //  : 0x02 0x1D 0x12 X1 Y1 X2 Y2 0x03 
;     783 // (X1, Y1)~(X2, Y2) -> X, Y ǥ Ʈ    
;     784 void Glib_Rectangle(unsigned int x1, unsigned int y1, unsigned int x2, unsigned int y2)               
;     785 {
_Glib_Rectangle:
;     786     RsOut1(STX);
	RCALL SUBOPT_0x24
;     787     RsOut1(0x1D);
;     788     RsOut1(0x12);    
	RCALL SUBOPT_0x18
;     789     RsOut1((unsigned char)((x1>>8)&0xFF));
	RCALL SUBOPT_0x26
;     790     RsOut1((unsigned char)(x1&0xFF)); 
;     791     RsOut1((unsigned char)((y1>>8)&0xFF));
	RCALL SUBOPT_0x27
;     792     RsOut1((unsigned char)(y1&0xFF));
	RCALL SUBOPT_0x28
;     793     RsOut1((unsigned char)((x2>>8)&0xFF));
	RCALL SUBOPT_0x22
;     794     RsOut1((unsigned char)(x2&0xFF)); 
;     795     RsOut1((unsigned char)((y2>>8)&0xFF));
;     796     RsOut1((unsigned char)(y2&0xFF));              
;     797     RsOut1(ETX);                   
;     798 }
	RJMP _0x90
;     799 
;     800 //-------------------- Glib_Circle Function ---------------------
;     801 //  : 0x02 0x1D 0x13 X0 Y0 Radius 0x03 
;     802 // (X0, Y0) -> X, Y ǥ Ʈ , Radius -> 
;     803 void Glib_Circle(unsigned int x0, unsigned int y0, unsigned char radius)               
;     804 {
_Glib_Circle:
;     805     RsOut1(STX);
	RCALL SUBOPT_0x24
;     806     RsOut1(0x1D);
;     807     RsOut1(0x13);    
	RCALL SUBOPT_0x1A
;     808     RsOut1((unsigned char)((x0>>8)&0xFF));
	LDD  R30,Y+4
	RCALL SUBOPT_0x27
;     809     RsOut1((unsigned char)(x0&0xFF)); 
	LDD  R30,Y+3
	LDD  R31,Y+3+1
	RCALL SUBOPT_0x29
;     810     RsOut1((unsigned char)((y0>>8)&0xFF));
	LDD  R30,Y+2
	RCALL SUBOPT_0x27
;     811     RsOut1((unsigned char)(y0&0xFF));
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	RCALL SUBOPT_0x29
;     812     RsOut1(radius);    
	RCALL SUBOPT_0x19
;     813     RsOut1(ETX);                   
;     814 }
	RJMP _0x91
;     815                
;     816 //-------------------- Glib_Ellipse Function ---------------------
;     817 //  : 0x02 0x1D 0x14 X0 Y0 a b 0x03 
;     818 // (X0, Y0) -> X, Y ǥ Ʈ  
;     819 // a -> Horizontal length, b -> Vertical length
;     820 void Glib_Ellipse(unsigned int x0, unsigned int y0, unsigned char a, unsigned char b)               
;     821 {
_Glib_Ellipse:
;     822     RsOut1(STX);
	RCALL SUBOPT_0x24
;     823     RsOut1(0x1D);
;     824     RsOut1(0x14);    
	LDI  R30,LOW(20)
	ST   -Y,R30
	RCALL _RsOut1
;     825     RsOut1((unsigned char)((x0>>8)&0xFF));
	LDD  R30,Y+5
	RCALL SUBOPT_0x27
;     826     RsOut1((unsigned char)(x0&0xFF)); 
	RCALL SUBOPT_0x28
;     827     RsOut1((unsigned char)((y0>>8)&0xFF));
	LDD  R30,Y+3
	RCALL SUBOPT_0x27
;     828     RsOut1((unsigned char)(y0&0xFF));                                               
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	RCALL SUBOPT_0x29
;     829     RsOut1(a);        
	LDD  R30,Y+1
	RCALL SUBOPT_0x2A
;     830     RsOut1(b);    
;     831     RsOut1(ETX);                   
;     832 }                                      
	ADIW R28,6
	RET
;     833 
;     834 //-------------------- Glib_Arc Function ---------------------
;     835 //  : 0x02 0x1D 0x15 X0 Y0 Radius StartAngle EndAngle 0x03 
;     836 // (X0, Y0) -> X, Y ǥ Ʈ , Radius -> 
;     837 // StartAngle -> ۰(2byte , 0~359)
;     838 // EndAngle -> (2byte , 0~359)
;     839 void Glib_Arc(unsigned int x0, unsigned int y0, unsigned char radius,
;     840               unsigned int sAngle, unsigned int eAngle)               
;     841 {
;     842     RsOut1(STX);
;     843     RsOut1(0x1D);
;     844     RsOut1(0x15);    
;     845     RsOut1((unsigned char)((x0>>8)&0xFF));
;     846     RsOut1((unsigned char)(x0&0xFF)); 
;     847     RsOut1((unsigned char)((y0>>8)&0xFF));
;     848     RsOut1((unsigned char)(y0&0xFF));
;     849     RsOut1(radius);                  
;     850     RsOut1((unsigned char)((sAngle>>8)&0xFF));
;     851     RsOut1((unsigned char)(sAngle&0xFF)); 
;     852     RsOut1((unsigned char)((eAngle>>8)&0xFF));
;     853     RsOut1((unsigned char)(eAngle&0xFF));    
;     854     RsOut1(ETX);                   
;     855 }
;     856              
;     857 //-------------------- Glib_FilledRectangle Function ---------------------
;     858 //  : 0x02 0x1D 0x16 X1 Y1 X2 Y2 FillColor 0x03 
;     859 // (X1, Y1)~(X2, Y2) -> X, Y ǥ Ʈ    
;     860 // FillColor -> R G B   1Ʈ  3Ʈ      
;     861 void Glib_FilledRectangle(unsigned int x1, unsigned int y1, unsigned int x2, unsigned int y2,
;     862                           unsigned long fillColor)               
;     863 {
_Glib_FilledRectangle:
;     864     RsOut1(STX);
	RCALL SUBOPT_0x24
;     865     RsOut1(0x1D);
;     866     RsOut1(0x16);    
	LDI  R30,LOW(22)
	ST   -Y,R30
	RCALL _RsOut1
;     867     RsOut1((unsigned char)((x1>>8)&0xFF));
	LDD  R30,Y+11
	RCALL SUBOPT_0x27
;     868     RsOut1((unsigned char)(x1&0xFF)); 
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	RCALL SUBOPT_0x29
;     869     RsOut1((unsigned char)((y1>>8)&0xFF));
	LDD  R30,Y+9
	RCALL SUBOPT_0x27
;     870     RsOut1((unsigned char)(y1&0xFF));
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	ANDI R31,HIGH(0xFF)
	RCALL SUBOPT_0x25
;     871     RsOut1((unsigned char)((x2>>8)&0xFF));
;     872     RsOut1((unsigned char)(x2&0xFF)); 
;     873     RsOut1((unsigned char)((y2>>8)&0xFF));
;     874     RsOut1((unsigned char)(y2&0xFF)); 
;     875     RsOut1((unsigned char)((fillColor>>16)&0xFF));
	__GETD1S 0
	RCALL SUBOPT_0x1E
;     876     RsOut1((unsigned char)((fillColor>>8)&0xFF));
	LD   R30,Y
	LDD  R31,Y+1
	RCALL SUBOPT_0x1F
;     877     RsOut1((unsigned char)(fillColor&0xFF));                  
	__GETD1S 0
	RCALL SUBOPT_0x20
;     878     RsOut1(ETX);                   
	RCALL SUBOPT_0x17
;     879 }
	ADIW R28,12
	RET
;     880 
;     881 //-------------------- Glib_FilledCircle Function ---------------------
;     882 //  : 0x02 0x1D 0x17 X0 Y0 Radius FillColor 0x03 
;     883 // (X0, Y0) -> X, Y ǥ Ʈ , Radius -> 
;     884 // FillColor -> R G B   1Ʈ  3Ʈ      
;     885 void Glib_FilledCircle(unsigned int x0, unsigned int y0, unsigned char radius, unsigned long fillColor)               
;     886 {
_Glib_FilledCircle:
;     887     RsOut1(STX);
	RCALL SUBOPT_0x24
;     888     RsOut1(0x1D);
;     889     RsOut1(0x17);    
	LDI  R30,LOW(23)
	ST   -Y,R30
	RCALL _RsOut1
;     890     RsOut1((unsigned char)((x0>>8)&0xFF));
	LDD  R30,Y+8
	RCALL SUBOPT_0x27
;     891     RsOut1((unsigned char)(x0&0xFF)); 
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	RCALL SUBOPT_0x29
;     892     RsOut1((unsigned char)((y0>>8)&0xFF));
	LDD  R30,Y+6
	RCALL SUBOPT_0x27
;     893     RsOut1((unsigned char)(y0&0xFF));
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	RCALL SUBOPT_0x29
;     894     RsOut1(radius);                         
	RCALL SUBOPT_0x2B
;     895     RsOut1((unsigned char)((fillColor>>16)&0xFF));
;     896     RsOut1((unsigned char)((fillColor>>8)&0xFF));
	LD   R30,Y
	LDD  R31,Y+1
	RCALL SUBOPT_0x1F
;     897     RsOut1((unsigned char)(fillColor&0xFF));    
	__GETD1S 0
	RCALL SUBOPT_0x20
;     898     RsOut1(ETX);                   
	RCALL SUBOPT_0x17
;     899 }
	ADIW R28,9
	RET
;     900 
;     901 //-------------------- Glib_FilledEllipse Function ---------------------
;     902 //  : 0x02 0x1D 0x18 X0 Y0 a b FillColor 0x03 
;     903 // (X0, Y0) -> X, Y ǥ Ʈ  
;     904 // a -> Horizontal length, b -> Vertical length           
;     905 // FillColor -> R G B   1Ʈ  3Ʈ      
;     906 void Glib_FilledEllipse(unsigned int x0, unsigned int y0, unsigned char a, unsigned char b,
;     907                         unsigned long fillColor)               
;     908 {
_Glib_FilledEllipse:
;     909     RsOut1(STX);
	RCALL SUBOPT_0x24
;     910     RsOut1(0x1D);
;     911     RsOut1(0x18);    
	LDI  R30,LOW(24)
	ST   -Y,R30
	RCALL _RsOut1
;     912     RsOut1((unsigned char)((x0>>8)&0xFF));
	LDD  R30,Y+9
	RCALL SUBOPT_0x27
;     913     RsOut1((unsigned char)(x0&0xFF)); 
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	RCALL SUBOPT_0x29
;     914     RsOut1((unsigned char)((y0>>8)&0xFF));
	RCALL SUBOPT_0x26
;     915     RsOut1((unsigned char)(y0&0xFF));                                               
;     916     RsOut1(a);        
	ST   -Y,R30
	RCALL _RsOut1
;     917     RsOut1(b);                                  
	RCALL SUBOPT_0x2B
;     918     RsOut1((unsigned char)((fillColor>>16)&0xFF));
;     919     RsOut1((unsigned char)((fillColor>>8)&0xFF));
	LD   R30,Y
	LDD  R31,Y+1
	RCALL SUBOPT_0x1F
;     920     RsOut1((unsigned char)(fillColor&0xFF));        
	__GETD1S 0
	RCALL SUBOPT_0x20
;     921     RsOut1(ETX);                   
	RCALL SUBOPT_0x17
;     922 }
	ADIW R28,10
	RET
;     923 
;     924 //-------------------- Glib_ClearScreen Function ---------------------
;     925 //  : 0x02 0x1D 0x19 FillColor 0x03 
;     926 // FillColor -> R G B   1Ʈ  3Ʈ      
;     927 void Glib_ClearScreen(unsigned long fillColor)               
;     928 {
_Glib_ClearScreen:
;     929     RsOut1(STX);
	RCALL SUBOPT_0x24
;     930     RsOut1(0x1D);
;     931     RsOut1(0x19);    
	LDI  R30,LOW(25)
	ST   -Y,R30
	RCALL _RsOut1
;     932     RsOut1((unsigned char)((fillColor>>16)&0xFF));
	__GETD1S 0
	RCALL SUBOPT_0x1E
;     933     RsOut1((unsigned char)((fillColor>>8)&0xFF));
	LD   R30,Y
	LDD  R31,Y+1
	RCALL SUBOPT_0x1F
;     934     RsOut1((unsigned char)(fillColor&0xFF));        
	__GETD1S 0
	RCALL SUBOPT_0x20
;     935     RsOut1(ETX);                   
	RCALL SUBOPT_0x17
;     936 }
	RJMP _0x8F
;     937 
;     938 //-------------------- Glib_ClearPartialScreen Function ---------------------
;     939 //  : 0x02 0x1D 0x1A X1 Y1 X2 Y2 FillColor 0x03 
;     940 // (X1, Y1)~(X2, Y2) -> X, Y ǥ Ʈ    
;     941 // FillColor -> R G B   1Ʈ  3Ʈ      
;     942 void Glib_ClearPartialScreen(unsigned int x1, unsigned int y1, unsigned int x2, unsigned int y2,
;     943                              unsigned long fillColor)               
;     944 {
;     945     RsOut1(STX);
;     946     RsOut1(0x1D);
;     947     RsOut1(0x1A);    
;     948     RsOut1((unsigned char)((x1>>8)&0xFF));
;     949     RsOut1((unsigned char)(x1&0xFF)); 
;     950     RsOut1((unsigned char)((y1>>8)&0xFF));
;     951     RsOut1((unsigned char)(y1&0xFF));
;     952     RsOut1((unsigned char)((x2>>8)&0xFF));
;     953     RsOut1((unsigned char)(x2&0xFF)); 
;     954     RsOut1((unsigned char)((y2>>8)&0xFF));
;     955     RsOut1((unsigned char)(y2&0xFF)); 
;     956     RsOut1((unsigned char)((fillColor>>16)&0xFF));
;     957     RsOut1((unsigned char)((fillColor>>8)&0xFF));
;     958     RsOut1((unsigned char)(fillColor&0xFF));                  
;     959     RsOut1(ETX);                   
;     960 }
;     961  
;     962 //-------------------- Glib_DisplayImage Function ---------------------
;     963 //  : 0x02 0x1D 0x1B ImageIndex X Y 0x03  
;     964 // ImageIndex -> Image Index
;     965 // X,Y -> X, Y ǥ Ʈ 
;     966 void Glib_DisplayImage(unsigned char imageIndex, unsigned int xx, unsigned int yy)               
;     967 {
_Glib_DisplayImage:
;     968     RsOut1(STX);
	RCALL SUBOPT_0x24
;     969     RsOut1(0x1D);
;     970     RsOut1(0x1B);                    
	LDI  R30,LOW(27)
	ST   -Y,R30
	RCALL _RsOut1
;     971     RsOut1(imageIndex);
	LDD  R30,Y+4
	RCALL SUBOPT_0x2C
;     972     RsOut1((unsigned char)((xx>>8)&0xFF));
;     973     RsOut1((unsigned char)(xx&0xFF)); 
;     974     RsOut1((unsigned char)((yy>>8)&0xFF));
;     975     RsOut1((unsigned char)(yy&0xFF));    
;     976     RsOut1(ETX);                   
;     977 }
_0x91:
	ADIW R28,5
	RET
;     978        
;     979 //-------------------- Glib_PushScreen Function ---------------------
;     980 //  : 0x02 0x1D 0x1C X1 Y1 X2 Y2 0x03 
;     981 // (X1, Y1)~(X2, Y2) -> X, Y ǥ Ʈ    
;     982 void Glib_PushScreen(unsigned int x1, unsigned int y1, unsigned int x2, unsigned int y2)               
;     983 {
_Glib_PushScreen:
;     984     RsOut1(STX);
	RCALL SUBOPT_0x24
;     985     RsOut1(0x1D);
;     986     RsOut1(0x1C);    
	LDI  R30,LOW(28)
	RCALL SUBOPT_0x25
;     987     RsOut1((unsigned char)((x1>>8)&0xFF));
;     988     RsOut1((unsigned char)(x1&0xFF)); 
;     989     RsOut1((unsigned char)((y1>>8)&0xFF));
;     990     RsOut1((unsigned char)(y1&0xFF));
;     991     RsOut1((unsigned char)((x2>>8)&0xFF));
	RCALL SUBOPT_0x22
;     992     RsOut1((unsigned char)(x2&0xFF)); 
;     993     RsOut1((unsigned char)((y2>>8)&0xFF));
;     994     RsOut1((unsigned char)(y2&0xFF));              
;     995     RsOut1(ETX);                   
;     996 }
_0x90:
	ADIW R28,8
	RET
;     997 
;     998 //-------------------- Glib_PopScreen Function ---------------------
;     999 //  : 0x02 0x1D 0x1D X Y 0x03 
;    1000 // X, Y -> X, Y ǥ Ʈ    
;    1001 void Glib_PopScreen(unsigned int xx, unsigned int yy)               
;    1002 {
_Glib_PopScreen:
;    1003     RsOut1(STX);
	RCALL SUBOPT_0x24
;    1004     RsOut1(0x1D);
;    1005     RsOut1(0x1D);    
	LDI  R30,LOW(29)
	RCALL SUBOPT_0x2C
;    1006     RsOut1((unsigned char)((xx>>8)&0xFF));
;    1007     RsOut1((unsigned char)(xx&0xFF)); 
;    1008     RsOut1((unsigned char)((yy>>8)&0xFF));
;    1009     RsOut1((unsigned char)(yy&0xFF));
;    1010     RsOut1(ETX);                   
;    1011 }
_0x8F:
	ADIW R28,4
	RET
;    1012 
;    1013 //-------------------- Glib_OutUserChar Function ---------------------
;    1014 //  : 0x02 0x1D 0x1E CharIndex 0x03 
;    1015 // X, Y -> X, Y ǥ Ʈ    
;    1016 void Glib_OutUserChar(unsigned char charIndex)               
;    1017 {
_Glib_OutUserChar:
;    1018     RsOut1(STX);
	RCALL SUBOPT_0x24
;    1019     RsOut1(0x1D);
;    1020     RsOut1(0x1E);    
	LDI  R30,LOW(30)
	RCALL SUBOPT_0x2A
;    1021     RsOut1(charIndex);    
;    1022     RsOut1(ETX);                   
;    1023 }                       
	RJMP _0x8E
;    1024 
;    1025 
;    1026 //==================================================================
;    1027 //                        Ÿ ɱ
;    1028 //==================================================================                                                                     
;    1029 
;    1030 //-------------------- Glib_TspBeepOnOff Function ---------------------
;    1031 //  : 0x02 0x1E 0x14 flag 0x03 
;    1032 // flag -> 0xA0(use beep), 0x0A(don't use beep, default)
;    1033 void Glib_TspBeepOnOff(unsigned char flag)
;    1034 {
_Glib_TspBeepOnOff:
;    1035     RsOut1(STX);
	RCALL SUBOPT_0x2D
;    1036     RsOut1(0x1E);
;    1037     RsOut1(0x14);    
	RCALL SUBOPT_0x1B
;    1038     RsOut1(flag);    
;    1039     RsOut1(ETX);    
;    1040 }
_0x8E:
	ADIW R28,1
	RET
;    1041                
;    1042 //----------------------- Glib_Beep Function ------------------------
;    1043 //  : 0x02 0x1E 0x14 ms 0x03 
;    1044 // ms -> milli second 2byte, Ʈ 
;    1045 void Glib_Beep(unsigned int ms)
;    1046 {
_Glib_Beep:
;    1047     RsOut1(STX);
	RCALL SUBOPT_0x2D
;    1048     RsOut1(0x1E);
;    1049     RsOut1(0x15);    
	RCALL SUBOPT_0x23
;    1050     RsOut1((unsigned char)((ms>>8)&0xFF));
	LDD  R30,Y+1
	RCALL SUBOPT_0x27
;    1051     RsOut1((unsigned char)(ms&0xFF)); 
	LD   R30,Y
	LDD  R31,Y+1
	RCALL SUBOPT_0x29
;    1052     RsOut1(ETX);    
	RCALL SUBOPT_0x17
;    1053 }
	ADIW R28,2
	RET
;    1054 
;    1055 //-------------------- Glib_OutSound Function ---------------------
;    1056 //  : 0x02 0x1E 0x14 SoundIndex 0x03 
;    1057 // SoundIndex -> 0~15
;    1058 void Glib_OutSound(unsigned char soundIndex)
;    1059 {
;    1060     RsOut1(STX);
;    1061     RsOut1(0x1E);
;    1062     RsOut1(0x16);    
;    1063     RsOut1(soundIndex);    
;    1064     RsOut1(ETX);    
;    1065 }
;    1066 
;    1067 
;    1068 
;    1069 
;    1070 
;    1071 
;    1072 
;    1073 
;    1074 
;    1075 
;    1076 
;    1077 
;    1078 
;    1079 
;    1080       


;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x0:
	LDD  R30,Y+6
	SUBI R30,-LOW(95)
	CLR  R31
	CLR  R22
	CLR  R23
	__PUTD1S 7
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x1:
	CALL __PUTPARD1
	RCALL _Glib_SetLineColor
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R19
	ST   -Y,R18
	LDI  R30,LOW(799)
	LDI  R31,HIGH(799)
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R19
	ST   -Y,R18
	RCALL _Glib_Line
	LDD  R30,Y+6
	SUBI R30,-LOW(1)
	STD  Y+6,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES
SUBOPT_0x2:
	LDI  R30,LOW(200)
	LDI  R31,HIGH(200)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Glib_Beep
	__GETD1N 0xFFFFFFFF
	CALL __PUTPARD1
	RJMP _Glib_ClearScreen

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x3:
	MOVW R30,R20
	ANDI R30,LOW(0xF)
	ANDI R31,HIGH(0xF)
	ST   -Y,R30
	RCALL _GetColor
	CALL __PUTPARD1
	RCALL _Glib_SetLineColor
	LDI  R30,LOW(400)
	LDI  R31,HIGH(400)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES
SUBOPT_0x4:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x5:
	MOVW R30,R20
	ANDI R30,LOW(0xF)
	ANDI R31,HIGH(0xF)
	ST   -Y,R30
	RCALL _GetColor
	CALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x6:
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x7:
	LDI  R30,LOW(200)
	LDI  R31,HIGH(200)
	ST   -Y,R31
	ST   -Y,R30
	RJMP _Glib_Beep

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x8:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x9:
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0xA:
	__GETD1N 0xFFFFFFFF
	CALL __PUTPARD1
	RJMP _Glib_ClearScreen

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xB:
	LDI  R30,LOW(800)
	LDI  R31,HIGH(800)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	LDI  R30,LOW(400)
	LDI  R31,HIGH(400)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xC:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0xD:
	RCALL _Glib_PopScreen
	LDI  R30,LOW(800)
	LDI  R31,HIGH(800)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0xE:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R18
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xF:
	LDI  R30,LOW(10)
	ST   -Y,R30
	RCALL _Glib_LcdBackLight
	RJMP SUBOPT_0x9

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x10:
	LDI  R30,LOW(160)
	ST   -Y,R30
	RJMP _Glib_LcdBackLight

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x11:
	RCALL _Glib_SetLocate
	MOVW R26,R16
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	CALL __MODW21U
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x12:
	ST   -Y,R20
	RCALL _Glib_SetZoomRate
	ST   -Y,R16
	RCALL _GetColor
	CALL __PUTPARD1
	__GETD1N 0xFFFFFFFF
	CALL __PUTPARD1
	RCALL _Glib_SetFontColor
	MOVW R30,R16
	SBIW R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x13:
	ADIW R30,2
	CALL __LSLW4
	MOVW R26,R30
	MOVW R30,R20
	CALL __MULW12U
	ST   -Y,R31
	ST   -Y,R30
	RJMP _Glib_SetLocate

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x14:
	LDI  R30,LOW(0)
	STS  152,R30
	LDI  R30,LOW(51)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x15:
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _RsOut1
	LDI  R30,LOW(26)
	ST   -Y,R30
	RJMP _RsOut1

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x16:
	LDI  R30,LOW(16)
	ST   -Y,R30
	RJMP _RsOut1

;OPTIMIZER ADDED SUBROUTINE, CALLED 26 TIMES
SUBOPT_0x17:
	LDI  R30,LOW(3)
	ST   -Y,R30
	RJMP _RsOut1

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x18:
	LDI  R30,LOW(18)
	ST   -Y,R30
	RJMP _RsOut1

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES
SUBOPT_0x19:
	LD   R30,Y
	ST   -Y,R30
	RCALL _RsOut1
	RJMP SUBOPT_0x17

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x1A:
	LDI  R30,LOW(19)
	ST   -Y,R30
	RJMP _RsOut1

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x1B:
	LDI  R30,LOW(20)
	ST   -Y,R30
	RCALL _RsOut1
	RJMP SUBOPT_0x19

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x1C:
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _RsOut1
	LDI  R30,LOW(27)
	ST   -Y,R30
	RJMP _RsOut1

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1D:
	LDI  R30,LOW(17)
	ST   -Y,R30
	RCALL _RsOut1
	RJMP SUBOPT_0x19

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES
SUBOPT_0x1E:
	CALL __LSRD16
	__ANDD1N 0xFF
	ST   -Y,R30
	RJMP _RsOut1

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES
SUBOPT_0x1F:
	MOV  R30,R31
	__ANDD1N 0xFF
	ST   -Y,R30
	RJMP _RsOut1

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES
SUBOPT_0x20:
	__ANDD1N 0xFF
	ST   -Y,R30
	RJMP _RsOut1

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x21:
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _RsOut1
	LDI  R30,LOW(28)
	ST   -Y,R30
	RJMP _RsOut1

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x22:
	LDD  R30,Y+3
	ANDI R31,HIGH(0x0)
	ST   -Y,R30
	RCALL _RsOut1
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ANDI R31,HIGH(0xFF)
	ST   -Y,R30
	RCALL _RsOut1
	LDD  R30,Y+1
	ANDI R31,HIGH(0x0)
	ST   -Y,R30
	RCALL _RsOut1
	LD   R30,Y
	LDD  R31,Y+1
	ANDI R31,HIGH(0xFF)
	ST   -Y,R30
	RCALL _RsOut1
	RJMP SUBOPT_0x17

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x23:
	LDI  R30,LOW(21)
	ST   -Y,R30
	RJMP _RsOut1

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES
SUBOPT_0x24:
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _RsOut1
	LDI  R30,LOW(29)
	ST   -Y,R30
	RJMP _RsOut1

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x25:
	ST   -Y,R30
	RCALL _RsOut1
	LDD  R30,Y+7
	ANDI R31,HIGH(0x0)
	ST   -Y,R30
	RCALL _RsOut1
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ANDI R31,HIGH(0xFF)
	ST   -Y,R30
	RCALL _RsOut1
	LDD  R30,Y+5
	ANDI R31,HIGH(0x0)
	ST   -Y,R30
	RCALL _RsOut1
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ANDI R31,HIGH(0xFF)
	ST   -Y,R30
	RJMP _RsOut1

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x26:
	LDD  R30,Y+7
	ANDI R31,HIGH(0x0)
	ST   -Y,R30
	RCALL _RsOut1
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ANDI R31,HIGH(0xFF)
	ST   -Y,R30
	RCALL _RsOut1
	LDD  R30,Y+5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES
SUBOPT_0x27:
	ANDI R31,HIGH(0x0)
	ST   -Y,R30
	RJMP _RsOut1

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x28:
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ANDI R31,HIGH(0xFF)
	ST   -Y,R30
	RJMP _RsOut1

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0x29:
	ANDI R31,HIGH(0xFF)
	ST   -Y,R30
	RJMP _RsOut1

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2A:
	ST   -Y,R30
	RCALL _RsOut1
	RJMP SUBOPT_0x19

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2B:
	LDD  R30,Y+4
	ST   -Y,R30
	RCALL _RsOut1
	__GETD1S 0
	RJMP SUBOPT_0x1E

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2C:
	ST   -Y,R30
	RCALL _RsOut1
	RJMP SUBOPT_0x22

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2D:
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _RsOut1
	LDI  R30,LOW(30)
	ST   -Y,R30
	RJMP _RsOut1

_strlenf:
	clr  r26
	clr  r27
	ld   r30,y+
	ld   r31,y+
__strlenf0:
	lpm  r0,z+
	tst  r0
	breq __strlenf1
	adiw r26,1
	rjmp __strlenf0
__strlenf1:
	movw r30,r26
	ret

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xFA0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__LSLD12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	MOVW R22,R24
	BREQ __LSLD12R
__LSLD12L:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R0
	BRNE __LSLD12L
__LSLD12R:
	RET

__LSLW4:
	LSL  R30
	ROL  R31
__LSLW3:
	LSL  R30
	ROL  R31
__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__LSRD16:
	MOV  R30,R22
	MOV  R31,R23
	LDI  R22,0
	LDI  R23,0
	RET

__LSLD16:
	MOV  R22,R30
	MOV  R23,R31
	LDI  R30,0
	LDI  R31,0
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__MODW21U:
	RCALL __DIVW21U
	MOVW R30,R26
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
