#include "UART1.h"
                   
#define SEI()   #asm("sei")

#define RXB8 1
#define TXB8 0
#define UPE  2
#define OVR  3
#define FE   4
#define UDRE 5
#define RXC  7

#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_OVERRUN (1<<OVR)
#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)
#define RX_BUFFER_SIZE1 128

// USART1 Receiver buffer & Variables
unsigned char rx_buffer1[RX_BUFFER_SIZE1];
unsigned char rx_wr_index1,rx_rd_index1,rx_counter1;
bit rx_buffer_overflow1;

//----------------- UART1 Receive ISR ----------------------------
interrupt [USART1_RXC] void usart1_rx_isr(void)
{
    unsigned char status,data;
    status=UCSR1A;
    data = UDR1;
    
//    if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0)
//   {
       rx_buffer1[rx_wr_index1]=data;
       if (++rx_wr_index1 == RX_BUFFER_SIZE1) 
           rx_wr_index1=0;
       if (++rx_counter1 == RX_BUFFER_SIZE1)
      {
          rx_counter1=0;
          rx_buffer_overflow1=1;
      }
//   }    
}                                     

//----------------- UART1 RsIn1 Function ------------------------
unsigned char RsIn1(void)
{
    char data;
    data=rx_buffer1[rx_rd_index1];
    if (++rx_rd_index1 == RX_BUFFER_SIZE1) 
        rx_rd_index1=0;
    #asm("cli")
    --rx_counter1;
    #asm("sei")
    return data;
}                          

//----------------- UART1 RsReady1 Function ---------------------
unsigned char RsReady1(void)
{
    if(rx_counter1>0)
        return(1);
    else
        return(0);        
}                 
                                              
//----------------- UART1 RsOut1 Function ----------------------
void RsOut1(char c)
{
    while ((UCSR1A & DATA_REGISTER_EMPTY)==0);
    UDR1=c;
}

//----------------- UART1 InitUart Function ----------------------
void InitUart(void)
{
    // USART1 initialization, 19200bps 8N1
    UCSR1A=0x00; UCSR1B=0x98; UCSR1C=0x06; UBRR1H=0x00; UBRR1L=0x33;
    UCSR0A=0x00; UCSR0B=0x98; UCSR0C=0x06; UBRR1H=0x00; UBRR0L=0x33;    
}
